const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const import_row_results = sequelize.define(
    'import_row_results',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

row_number: {
        type: DataTypes.INTEGER,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"valid",


"invalid",


"warning",


"skipped"

        ],

      },

raw_row: {
        type: DataTypes.TEXT,
      
      

      },

normalized_row: {
        type: DataTypes.TEXT,
      
      

      },

primary_key_hint: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  import_row_results.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
















    db.import_row_results.hasMany(db.import_issues, {
      as: 'import_issues_row_result',
      foreignKey: {
          name: 'row_resultId',
      },
      constraints: false,
    });









//end loop



    db.import_row_results.belongsTo(db.import_jobs, {
      as: 'import_job',
      foreignKey: {
        name: 'import_jobId',
      },
      constraints: false,
    });

    db.import_row_results.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.import_row_results.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.import_row_results.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return import_row_results;
};


